package com.joe.print.mvp.model;

import android.app.Application;

import com.gingersoft.gsa.cloud.common.bean.BaseResult;
import com.google.gson.Gson;
import com.jess.arms.di.scope.ActivityScope;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;
import com.joe.print.mvp.contract.PrinterAddContract;
import com.joe.print.mvp.model.server.PrintInfoService;

import javax.inject.Inject;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 01/16/2020 16:23
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@ActivityScope
public class PrinterAddModel extends BaseModel implements PrinterAddContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public PrinterAddModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }

    @Override
    public Observable<BaseResult> addPrinter(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(PrintInfoService.class)
                .addPrinter(requestBody);
    }
    @Override
    public Observable<BaseResult> updatePrinter(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(PrintInfoService.class)
                .updatePrinter(requestBody);
    }

    @Override
    public Observable<BaseResult> getPrintModel(int restaurantId) {
        return mRepositoryManager.obtainRetrofitService(PrintInfoService.class)
                .getPrinterModelList(restaurantId);
    }

}